//----------------------------------------------------------------------------------
//aviutlvOC r[gmCYጸtB^
// Copyright (c) 2005  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <tchar.h>
#include <mmintrin.h>
#include <shlwapi.h>

#include "filter.h"
#include "anti_beat.h"
#include "util.h"

//#include "rdtsc.h"

//---------------------------------------------------------------------
// ftHg̃t@CƃtB^
//---------------------------------------------------------------------
TCHAR default_fime_name[] = _T("anti_beat.auf");
TCHAR filter_name[128] = _T("r[gmCYጸ");

//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
TCHAR *track_name[] = {"CH", "He", "H", "Ve", "V", "臒l", "ی", "x" };
int   track_default[] = { 0, 0, 0, 0, 0, 4, 0, 8 };
int   track_s[] = { 0, -256, -256, -256, -256,   0, 0,  0 };
int   track_e[] = { 2,  256,  256,  256,  256, 256, 3, 16 };

TCHAR *check_name[] = { "ubNɏ", "\", "g\", "ʑ\"};
int    check_default[] = { 0, 0, 0, 0 };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, 0,0,
  filter_name,
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,
  NULL,
  func_exit,
  NULL, NULL, NULL, NULL, NULL, 0,
  "anti_beat by N099, ver1.3",
  NULL,  NULL,

};


//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
short *g_tbl_c = NULL;
short *g_tbl_s = NULL;
short *g_tmp = NULL;

//---------------------------------------------------------------------
//     DLL̃Gg|Cg
//---------------------------------------------------------------------
BOOL APIENTRY DllMain(HANDLE hModule, DWORD reason, LPVOID Reserved)
{
  if(reason == DLL_PROCESS_ATTACH){
    //t@CύXĂꍇAtB^ύX
    TCHAR name[MAX_PATH];
    if(GetModuleFileName(hModule, name, ARRAYSIZE(name) - 1)){
      PathStripPath(name);
      if(_tcscmp(name, default_fime_name)){
        PathRemoveExtension(name);
        _tcscat(filter_name, &name[_tcslen(name)-1]);
      }
    }
  }

  return TRUE;
}

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
  if(NULL != g_tbl_c){
    _aligned_free(g_tbl_c);
    g_tbl_c = NULL;
  }
  if(NULL != g_tbl_s){
    _aligned_free(g_tbl_s);
    g_tbl_s = NULL;
  }
  if(NULL != g_tmp){
    _aligned_free(g_tmp);
    g_tmp = NULL;
  }
  
  return TRUE;
}

//---------------------------------------------------------------------
// ̈m
//---------------------------------------------------------------------
BOOL malloc_temp(int h, int max_w)
{
  static int width = -1;
  static int height = -1;

  if(max_w == width && h == height && g_tbl_c && g_tbl_s && g_tmp){
    return TRUE;
  }

  // TCYωꍇÄfree
  func_exit(NULL);

  // 16byteɃAC
  g_tbl_c = _aligned_malloc(max_w * h * sizeof(short), 16);
  g_tbl_s = _aligned_malloc(max_w * h * sizeof(short), 16);
  g_tmp = _aligned_malloc(max_w * h * sizeof(int), 16);
  
  if(NULL == g_tbl_c || NULL == g_tbl_s || NULL == g_tmp){
    func_exit(NULL);
    return FALSE;
  }
  
  width = max_w;
  height = h;
  
  return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  CS_PROD cs;
  TCHAR buff[256];
  
  //ʑope[ü̊m
  if(!malloc_temp(fpip->h, fpip->max_w))
    return FALSE;

  //ʑope[u̍쐬
  if(make_tbl(fp, fpip, g_tbl_c, g_tbl_s))
    return FALSE;
  
  //g\
  if(fp->check[C_2DFREQ]){
    //+̕\
    if(fp->check[C_DISP_BEAT]){
      disp_beat(fp, fpip, g_tbl_c);
    }
    disp_2dfreq(fp, fpip);
    return TRUE;
  }
  
  //̕\
  if(fp->check[C_DISP_BEAT]){
    disp_beat(fp, fpip, g_tbl_c);
    return TRUE;
  }

  //tmStart();
    
  //`lꎞ̈ɃRs[
  unpack_data((short *)fpip->ycp_temp, fpip->ycp_edit, fpip, fp->track[T_CH]);

  //r[g̈ʑƐUoČZ
  if(fp->check[C_BLOCK]){
    //r[g̕zɉ
    cs = prod_beat_b((short *)fpip->ycp_temp, g_tbl_c, g_tbl_s, fpip);
    
    //臒l𒴂ꍇ̂ݏ
    if((cs.c * cs.c + cs.s * cs.s) >= (fp->track[T_TH] * fp->track[T_TH])){
      detect_beat((short *)fpip->ycp_temp, g_tmp, fp, fpip, &cs);
      sub_beat_b((short *)fpip->ycp_temp, g_tbl_c, g_tbl_s, fpip);
      //f[^ɖ߂
      pack_data(fpip->ycp_edit,(short *)fpip->ycp_temp, fpip, fp->track[T_CH]);
    }
  }else{
    //Ŝlɏ
    cs = prod_beat_a((short *)fpip->ycp_temp, g_tbl_c, g_tbl_s, fpip);

    //臒l𒴂ꍇ̂ݏ
    if((cs.c * cs.c + cs.s * cs.s) > (fp->track[T_TH] * fp->track[T_TH])){
      sub_beat_a((short *)fpip->ycp_temp, g_tbl_c, g_tbl_s, fpip, &cs);
      //f[^ɖ߂
      pack_data(fpip->ycp_edit,(short *)fpip->ycp_temp, fpip, fp->track[T_CH]);
    }
  }
  
  //tmStop();
  //tmCalc();
  
  //ol\
  if(!fp->exfunc->is_saving(fpip->editp)){
    int i;
    _mm_empty();
    i = (int)(sqrt(cs.c * cs.c + cs.s * cs.s) + 0.5);
    _sntprintf(buff, ARRAYSIZE(buff), _T("%s U:%d"), filter.name, i);
    //_sntprintf(buff, ARRAYSIZE(buff), _T("%s U:%d CLK:%lu"), filter.name, i, elapsed_time);
    buff[ARRAYSIZE(buff) - 1] = 0;
    SetWindowText(fp->hwnd, buff);
  }
  
  return TRUE;
}

